"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var token_1 = __importDefault(require("./lib/token"));
function default_1(options) {
    return function (req, res, next) {
        var _a;
        if (req.method === 'OPTIONS') {
            return next();
        }
        var encodedJwt;
        if (((_a = req.headers) === null || _a === void 0 ? void 0 : _a.authorization) !== undefined) {
            var parts = req.headers.authorization.split(' ');
            if (parts.length === 2 && parts[0] === 'Bearer') {
                encodedJwt = parts[1];
            }
        }
        req.token = new token_1.default(encodedJwt, options.secretOrPublicKey);
        next();
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map