"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var http_errors_1 = __importDefault(require("http-errors"));
var Status;
(function (Status) {
    Status[Status["Fresh"] = 0] = "Fresh";
    Status[Status["Passing"] = 1] = "Passing";
    Status[Status["Failed"] = 2] = "Failed";
    Status[Status["Passed"] = 3] = "Passed";
})(Status || (Status = {}));
var Require = /** @class */ (function () {
    function Require(token) {
        var _this = this;
        this._status = Status.Fresh;
        this.role = function (name) {
            var _a;
            var currentStatus = _this._status;
            if (currentStatus === Status.Passed || currentStatus === Status.Failed) {
                return _this;
            }
            var hasRole = (_a = _this._token.roles) === null || _a === void 0 ? void 0 : _a.includes(name);
            if (!hasRole) {
                _this._status = Status.Failed;
            }
            else {
                _this._status = Status.Passing;
            }
            return _this;
        };
        this.claim = function (name, value) {
            var _a;
            var currentStatus = _this._status;
            if (currentStatus === Status.Passed || currentStatus === Status.Failed) {
                return _this;
            }
            var compareValue = (_a = _this._token.claims) === null || _a === void 0 ? void 0 : _a[name];
            if (compareValue === undefined || compareValue !== value) {
                _this._status = Status.Failed;
            }
            else {
                _this._status = Status.Passing;
            }
            return _this;
        };
        this.guard = function (message) {
            _this._token.requireValid();
            if (!_this.check) {
                throw new http_errors_1.default.Forbidden(message);
            }
        };
        this._token = token;
    }
    Object.defineProperty(Require.prototype, "and", {
        get: function () {
            return this;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Require.prototype, "or", {
        get: function () {
            var currentStatus = this._status;
            if (currentStatus === Status.Passed) {
                return this;
            }
            if (currentStatus === Status.Passing) {
                this._status = Status.Passed;
                return this;
            }
            this._status = Status.Fresh;
            return this;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Require.prototype, "check", {
        get: function () {
            if (!this._token.valid) {
                return false;
            }
            var currentStatus = this._status;
            if (currentStatus === Status.Passing || currentStatus === Status.Passed) {
                return true;
            }
            return false;
        },
        enumerable: false,
        configurable: true
    });
    return Require;
}());
exports.default = Require;
//# sourceMappingURL=require.js.map